{ SmtpMailXControl1_TLB.pas  SMTP interface component

 	Copyright (C) 2003 - 20xx Stephan Stapel
        (stephan.stapel@web.de)

  This file is part of gnupgcomponents, ocx package.

  GnuPGEngine and GnuPGPublickeyring is free software;
  you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit SmtpMailXControl1_TLB;

// ************************************************************************ //
// WARNUNG                                                                    
// -------                                                                    
// Die in dieser Datei deklarierten Typen wurden aus Daten einer Typbibliothek
// generiert. Wenn diese Typbibliothek explizit oder indirekt (ber eine     
// andere Typbibliothek) reimportiert wird oder wenn die Anweisung            
// 'Aktualisieren' im Typbibliotheks-Editor whrend des Bearbeitens der     
// Typbibliothek aktiviert ist, wird der Inhalt dieser neu generiert und alle 
// manuell vorgenommenen nderungen gehen verloren.                           
// ************************************************************************ //

// PASTLWTR : $Revision:   1.88  $
// Datei generiert am 08.10.2002 22:32:01 aus der unten beschriebenen Typbibliothek.

// *************************************************************************//
// HINWEIS:                                                                   
// Eintrge, die von $IFDEF_LIVE_SERVER_AT_DESIGN_TIME berwacht sind,        
// werden von Eigenschaften verwendet, die Objekte zurckgeben, die           
// explizit ber einen Funktionsaufruf vor dem Zugriff durch die              
// Eigenschaft erzeugt werden mssen. Diese Eintrge wurden deaktiviert,      
// um eine unbeabsichtigte Nutzung aus dem Objektinspektor heraus zu          
// verhindern. Sie knnen sie aktivieren, indem Sie                           
// LIVE_SERVER_AT_DESIGN_TIME definieren oder durch selektives Entfernen aus  
// den $IFDEF-Blcken. Wie auch immer, diese Eintrge mssen                  
// weiterhin programmiererisch ber eine Methode der passenden CoClass        
// erzeugt werden, bevor sie verwendet werden knnen.                         
// ************************************************************************ //
// Typbib: D:\delphi50\Projects\smtpocx\SmtpMailXControl1.tlb (1)
// IID\LCID: {FFAD12B1-F26F-439B-9A6B-7DAC20D5058F}\0
// Hilfedatei: 
// AbhLst: 
//   (1) v2.0 stdole, (C:\winnt\System32\STDOLE2.TLB)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, OleCtrls, StdVCL;

// *********************************************************************//
// In dieser Typbibliothek deklarierte GUIDS . Es werden folgende         
// Prfixe verwendet:                                                     
//   Typbibliotheken     : LIBID_xxxx                                     
//   CoClasses           : CLASS_xxxx                                     
//   DISPInterfaces      : DIID_xxxx                                      
//   Non-DISP interfaces : IID_xxxx                                       
// *********************************************************************//
const
  // Haupt- und Nebenversionen der Typbibliothek
  SmtpMailXControl1MajorVersion = 1;
  SmtpMailXControl1MinorVersion = 0;

  LIBID_SmtpMailXControl1: TGUID = '{FFAD12B1-F26F-439B-9A6B-7DAC20D5058F}';

  IID_ISmtpMailX: TGUID = '{66C8B240-8204-40D7-9520-2670B267FE3F}';
  DIID_ISmtpMailXEvents: TGUID = '{869F20A1-288D-486A-BC4B-CA8ABB6A0A51}';
  CLASS_SmtpMailX: TGUID = '{79766A7F-90D7-4143-8B23-83A78097E880}';
type

// *********************************************************************//
// Forward-Deklaration von in der Typbibliothek definierten Typen         
// *********************************************************************//
  ISmtpMailX = interface;
  ISmtpMailXDisp = dispinterface;
  ISmtpMailXEvents = dispinterface;

// *********************************************************************//
// Deklaration von in der Typbibliothek definierten CoClasses             
// (HINWEIS: Hier wird jede CoClass zu ihrer Standardschnittstelle        
// zugewiesen)                                                            
// *********************************************************************//
  SmtpMailX = ISmtpMailX;


// *********************************************************************//
// Schnittstelle: ISmtpMailX
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {66C8B240-8204-40D7-9520-2670B267FE3F}
// *********************************************************************//
  ISmtpMailX = interface(IDispatch)
    ['{66C8B240-8204-40D7-9520-2670B267FE3F}']
    procedure NewMessage(const aFromAdress: WideString; const aSubject: WideString); safecall;
    procedure AddLine(const aLine: WideString); safecall;
    function  Send: WordBool; safecall;
    procedure SetToAdress(const aToAdress: WideString); safecall;
    procedure SetFromAdress(const aFromAdress: WideString); safecall;
    procedure SetSubject(const aSubject: WideString); safecall;
    procedure AddAttachment(const anAttachment: WideString); safecall;
    procedure AddCCRecipients(const aCCRecipient: WideString); safecall;
    procedure SetHost(const aHost: WideString); safecall;
    procedure SetUserID(const anUserID: WideString); safecall;
    procedure ClearAttachments; safecall;
    procedure ClearLines; safecall;
    function  LastError: WideString; safecall;
    function  WasSuccessful: WordBool; safecall;
    procedure SetDebugMode; safecall;
    procedure SetWorkMode; safecall;
    procedure SetSubType(aSubType: Integer); safecall;
    procedure AddBCCRecipients(const aBCCRecipient: WideString); safecall;
    procedure ClearAllRecipients; safecall;
  end;

// *********************************************************************//
// DispIntf:  ISmtpMailXDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {66C8B240-8204-40D7-9520-2670B267FE3F}
// *********************************************************************//
  ISmtpMailXDisp = dispinterface
    ['{66C8B240-8204-40D7-9520-2670B267FE3F}']
    procedure NewMessage(const aFromAdress: WideString; const aSubject: WideString); dispid 19;
    procedure AddLine(const aLine: WideString); dispid 20;
    function  Send: WordBool; dispid 21;
    procedure SetToAdress(const aToAdress: WideString); dispid 22;
    procedure SetFromAdress(const aFromAdress: WideString); dispid 23;
    procedure SetSubject(const aSubject: WideString); dispid 24;
    procedure AddAttachment(const anAttachment: WideString); dispid 25;
    procedure AddCCRecipients(const aCCRecipient: WideString); dispid 26;
    procedure SetHost(const aHost: WideString); dispid 27;
    procedure SetUserID(const anUserID: WideString); dispid 28;
    procedure ClearAttachments; dispid 29;
    procedure ClearLines; dispid 30;
    function  LastError: WideString; dispid 31;
    function  WasSuccessful: WordBool; dispid 32;
    procedure SetDebugMode; dispid 33;
    procedure SetWorkMode; dispid 34;
    procedure SetSubType(aSubType: Integer); dispid 3;
    procedure AddBCCRecipients(const aBCCRecipient: WideString); dispid 4;
    procedure ClearAllRecipients; dispid 6;
  end;

// *********************************************************************//
// DispIntf:  ISmtpMailXEvents
// Flags:     (4096) Dispatchable
// GUID:      {869F20A1-288D-486A-BC4B-CA8ABB6A0A51}
// *********************************************************************//
  ISmtpMailXEvents = dispinterface
    ['{869F20A1-288D-486A-BC4B-CA8ABB6A0A51}']
  end;


// *********************************************************************//
// Klassendeklaration von OLE-Control-Proxy
// Elementname     : TSmtpMailX
// Hilfe-String      : SmtpMailX Element
// Standardschnittstelle: ISmtpMailX
// Def. Intf. DISP? : No
// Ereignisschnittstelle: ISmtpMailXEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//
  TSmtpMailX = class(TOleControl)
  private
    FIntf: ISmtpMailX;
    function  GetControlInterface: ISmtpMailX;
  protected
    procedure CreateControl;
    procedure InitControlData; override;
  public
    procedure NewMessage(const aFromAdress: WideString; const aSubject: WideString);
    procedure AddLine(const aLine: WideString);
    function  Send: WordBool;
    procedure SetToAdress(const aToAdress: WideString);
    procedure SetFromAdress(const aFromAdress: WideString);
    procedure SetSubject(const aSubject: WideString);
    procedure AddAttachment(const anAttachment: WideString);
    procedure AddCCRecipients(const aCCRecipient: WideString);
    procedure SetHost(const aHost: WideString);
    procedure SetUserID(const anUserID: WideString);
    procedure ClearAttachments;
    procedure ClearLines;
    function  LastError: WideString;
    function  WasSuccessful: WordBool;
    procedure SetDebugMode;
    procedure SetWorkMode;
    procedure SetSubType(aSubType: Integer);
    procedure AddBCCRecipients(const aBCCRecipient: WideString);
    procedure ClearAllRecipients;
    property  ControlInterface: ISmtpMailX read GetControlInterface;
    property  DefaultInterface: ISmtpMailX read GetControlInterface;
  published
    property  TabStop;
    property  Align;
    property  DragCursor;
    property  DragMode;
    property  ParentShowHint;
    property  PopupMenu;
    property  ShowHint;
    property  TabOrder;
    property  Visible;
    property  OnDragDrop;
    property  OnDragOver;
    property  OnEndDrag;
    property  OnEnter;
    property  OnExit;
    property  OnStartDrag;
  end;

procedure Register;

implementation

uses ComObj;

procedure TSmtpMailX.InitControlData;
const
  CLicenseKey: array[0..38] of Word = ( $007B, $0035, $0045, $0038, $0046, $0034, $0043, $0035, $0034, $002D, $0042
    , $0042, $0036, $0032, $002D, $0034, $0039, $0030, $0033, $002D, $0042
    , $0037, $0046, $0043, $002D, $0038, $0031, $0042, $0045, $0033, $0031
    , $0037, $0033, $0044, $0046, $0035, $0038, $007D, $0000);
  CControlData: TControlData2 = (
    ClassID: '{79766A7F-90D7-4143-8B23-83A78097E880}';
    EventIID: '';
    EventCount: 0;
    EventDispIDs: nil;
    LicenseKey: @CLicenseKey;
    Flags: $00000000;
    Version: 401);
begin
  ControlData := @CControlData;
end;

procedure TSmtpMailX.CreateControl;

  procedure DoCreate;
  begin
    FIntf := IUnknown(OleObject) as ISmtpMailX;
  end;

begin
  if FIntf = nil then DoCreate;
end;

function TSmtpMailX.GetControlInterface: ISmtpMailX;
begin
  CreateControl;
  Result := FIntf;
end;

procedure TSmtpMailX.NewMessage(const aFromAdress: WideString; const aSubject: WideString);
begin
  DefaultInterface.NewMessage(aFromAdress, aSubject);
end;

procedure TSmtpMailX.AddLine(const aLine: WideString);
begin
  DefaultInterface.AddLine(aLine);
end;

function  TSmtpMailX.Send: WordBool;
begin
  Result := DefaultInterface.Send;
end;

procedure TSmtpMailX.SetToAdress(const aToAdress: WideString);
begin
  DefaultInterface.SetToAdress(aToAdress);
end;

procedure TSmtpMailX.SetFromAdress(const aFromAdress: WideString);
begin
  DefaultInterface.SetFromAdress(aFromAdress);
end;

procedure TSmtpMailX.SetSubject(const aSubject: WideString);
begin
  DefaultInterface.SetSubject(aSubject);
end;

procedure TSmtpMailX.AddAttachment(const anAttachment: WideString);
begin
  DefaultInterface.AddAttachment(anAttachment);
end;

procedure TSmtpMailX.AddCCRecipients(const aCCRecipient: WideString);
begin
  DefaultInterface.AddCCRecipients(aCCRecipient);
end;

procedure TSmtpMailX.SetHost(const aHost: WideString);
begin
  DefaultInterface.SetHost(aHost);
end;

procedure TSmtpMailX.SetUserID(const anUserID: WideString);
begin
  DefaultInterface.SetUserID(anUserID);
end;

procedure TSmtpMailX.ClearAttachments;
begin
  DefaultInterface.ClearAttachments;
end;

procedure TSmtpMailX.ClearLines;
begin
  DefaultInterface.ClearLines;
end;

function  TSmtpMailX.LastError: WideString;
begin
  Result := DefaultInterface.LastError;
end;

function  TSmtpMailX.WasSuccessful: WordBool;
begin
  Result := DefaultInterface.WasSuccessful;
end;

procedure TSmtpMailX.SetDebugMode;
begin
  DefaultInterface.SetDebugMode;
end;

procedure TSmtpMailX.SetWorkMode;
begin
  DefaultInterface.SetWorkMode;
end;

procedure TSmtpMailX.SetSubType(aSubType: Integer);
begin
  DefaultInterface.SetSubType(aSubType);
end;

procedure TSmtpMailX.AddBCCRecipients(const aBCCRecipient: WideString);
begin
  DefaultInterface.AddBCCRecipients(aBCCRecipient);
end;

procedure TSmtpMailX.ClearAllRecipients;
begin
  DefaultInterface.ClearAllRecipients;
end;

procedure Register;
begin
  RegisterComponents('ActiveX',[TSmtpMailX]);
end;

end.
